//object settings
autowatch = 1;
var outlets = 1;
var serverOutlet = 0;

//prgram vars

var counter = 0;
var classType = "object";
var namespace = "/paperserver/MaxLib/data";
var _roll = null;


function bang()
{
    counter = 0;    
    //exportPatch();
    exportObjects();
	//end();
}

//to update one object... need to send the scripting name as argument
function exportobj(objname){
	var obj = _$(objname);
	//	post(objname+ " " + obj.maxclass+ " " + obj.varname+  "\n");
        if(obj!=null){
		export2anoto(obj);
	}
}
	
function exportObjects(){
	if(this.patcher.parentpatcher!=null){
   		this.patcher.parentpatcher.applydeep(export2anoto);
	}
}

//recursive function
 function export2anoto(a)
 {  
  //only process named variables
  if(a.varname!=""){
  post(a.varname + " " + a.maxclass +  " "+ a.getvalueof() + "\n");
	if(a.maxclass == "slider"||a.maxclass=="number" || a .maxclass =="flonum" || a.maxclass =="dial"){
        exportPValue(a);
    }else if (a.maxclass=="function"){
        exportGraph(a);
    }else if (a.maxclass=="bach.roll"){
        exportroll(a);
    }else if (a.maxclass=="toggle"){
        exporttoggle(a);
    }else if (a.maxclass=="button"){
        exportbutton(a);
    }else if (a.maxclass=="pictslider"){
        exportpictslider(a);
    }
   }
    return true;
}

function exporttoggle(toggle){
	post("Not implemented yet for toggle \n");
}

function exportbutton(button){
	post("Not implemented yet for button \n");
}

function exportpictslider(pictslider){
	outlet(serverOutlet, namespace, "add", "P2DValue", pictslider.varname);
	//TODO rangle for BiSlider....
    mess = "/" + pictslider.varname;
	mess= namespace + mess;
    outlet(serverOutlet, mess, "setvalue",pictslider.getvalueof());
}

function exportPValue(slider){
    outlet(serverOutlet, namespace, "add", "PValue", slider.varname);

    if(slider.maxclass=="number" || slider.maxclass =="flonum"){

    }else{
        extractAndSetRange(slider); 
    }

    mess = "/" + slider.varname;
	mess= namespace + mess;
    outlet(serverOutlet, mess, "setvalue",slider.getvalueof());
}

function extractAndSetRange(slider){
  //need to do some crappy stuff here....
   mess = "/" + slider.varname;
   var original = slider.getvalueof();
   var tmp = original;
   var mini = original;
   var maxi = mini;

   while(mini==tmp&&mini>-1000){
    mini = mini-1;
    slider.setvalueof(mini);
    tmp = slider.getvalueof();
   }
   mini = tmp;

    slider.setvalueof(original);
    tmp = original;

   while (maxi==tmp&&maxi<2000){
    maxi = maxi*1+1;
    slider.setvalueof(maxi);
    tmp = slider.getvalueof();
   }
   maxi = tmp;

  slider.setvalueof(original);
	mess= namespace + mess;
  outlet(serverOutlet,mess, "setrange", mini, maxi);
}

function exportGraph(a){
    outlet(serverOutlet, namespace, "add", "PCurve", a.varname);

    mess = "/" + a.varname;
	mess= namespace + mess;
    outlet(serverOutlet, mess, "clear");

    var dump = a.getvalueof();
    var domain = dump[0];
    var y_min = dump[1];
    var y_max = dump[2];
    mess = "/" + a.varname;
	mess= namespace + mess;
    outlet(serverOutlet, mess, "setrange", 0, domain, y_min, y_max);

	var inc = 3;
	//in case the function is in curve mode, ignore curve params...
	if(dump[dump.length - 1]=="curve"){
		inc = 5;
	}
	
	var points = new Array();
	var lastVal = -1;

    for(var i = 3; i<dump.length - 1;i= i + inc){
      		points.push(dump[i]);
      		points.push(dump[i+1]);
			lastVal = dump[i+1];
		if(points.length > 200){
			mess = "/" + a.varname;
			mess= namespace + mess;
			outlet(serverOutlet, mess,"addpoints",points);
			points= new Array();
		}
	}
	mess = "/" + a.varname;
	mess= namespace + mess;
	outlet(serverOutlet, mess,"addpoints",points);
}

function exportroll(a){
    outlet(serverOutlet, namespace, "add", "PChordSeq", a.varname);
    mess = "/" + a.varname;
    mess= namespace + mess;
    outlet(serverOutlet, mess, "clear");
    _roll = a;
    a.message("dump");
}

//this method will be called by the roll
function rollexport(){

  if(_roll!=null){

   // post( arguments.length + "\n");
    var list = new Array();
    
    for(var j = 0; j<arguments.length; j++){
      if(arguments[j]!= ")" && arguments[j]!="("){
        list.push(arguments[j]);
      }
    }

   // post("list " + list.length + " " + list + "\n");
  
    var nb_elem = list.length/3;
    //post("nb elem " + nb_elem + "\n");
    
    if(nb_elem>0){
      var chords = new Array();
      for(var i = 0; i < nb_elem ; i++){
        chords.push(list[i]);
        chords.push(list[i+nb_elem]);
        chords.push(list[i+2*nb_elem]);
  		
		if(chords.length > 200){
		 	mess = "/" + _roll.varname;
      		mess= namespace + mess;
      		//post("chords"+"\n");
      		outlet(serverOutlet, mess,"addnotes",chords);
			chords= new Array();
		}
     }
     //post("hey " + chords.length + " " + chords + "\n" );
      mess = "/" + _roll.varname;
      mess= namespace + mess;
      post(chords+"\n");
      outlet(serverOutlet, mess,"addnotes",chords);

    }else{
      post("empty roll \n")
    }
    _roll = null;
  }

}

function _$(id){ //search through all max objects:
    tempobj=0
    tempname=id
    this.patcher.parentpatcher.applydeepif (_$act,_$scan);
    delete tempname
    return(tempobj)
}
function _$act(obj){
    tempobj=obj
}
function _$scan(obj){
    if(obj.varname==tempname){
        return(true)
    }else{
        return(false)
    }
}
     



